tests: test terminal output to both stdout and stderr
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
18508c39 46unset GIT_EDITOR
e1970ce4
JH
47unset AUTHOR_DATE
48unset AUTHOR_EMAIL
49unset AUTHOR_NAME
50unset COMMIT_AUTHOR_EMAIL
51unset COMMIT_AUTHOR_NAME
28a94f88 52unset EMAIL
e1970ce4
JH
53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54unset GIT_AUTHOR_DATE
29e55cd5
JH
55GIT_AUTHOR_EMAIL=author@example.com
56GIT_AUTHOR_NAME='A U Thor'
6677c466 57unset GIT_COMMITTER_DATE
29e55cd5
JH
58GIT_COMMITTER_EMAIL=committer@example.com
59GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
60unset GIT_DIFF_OPTS
61unset GIT_DIR
892c41b9 62unset GIT_WORK_TREE
e1970ce4
JH
63unset GIT_EXTERNAL_DIFF
64unset GIT_INDEX_FILE
65unset GIT_OBJECT_DIRECTORY
0454dd93 66unset GIT_CEILING_DIRECTORIES
e1970ce4
JH
67unset SHA1_FILE_DIRECTORIES
68unset SHA1_FILE_DIRECTORY
6ceeaee7 69unset GIT_NOTES_REF
894a9d33 70unset GIT_NOTES_DISPLAY_REF
6956f858
TR
71unset GIT_NOTES_REWRITE_REF
72unset GIT_NOTES_REWRITE_MODE
8d0fc48f
SP
73GIT_MERGE_VERBOSITY=5
74export GIT_MERGE_VERBOSITY
29e55cd5
JH
75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 77export EDITOR
e1970ce4 78
886a3907
JH
79# Protect ourselves from common misconfiguration to export
80# CDPATH into the environment
81unset CDPATH
82
5565f47c
BW
83unset GREP_OPTIONS
84
3d5c0cc9 85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
91 ;;
92esac
93
cd3c095c
JH
94# Convenience
95#
96# A regexp to match 5 and 40 hexdigits
97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
e1970ce4
JH
100# Each test should start with something like this, after copyright notices:
101#
102# test_description='Description of this test...
103# This test checks if command xyzzy does the right thing...
104# '
105# . ./test-lib.sh
c2116a17
JH
106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
55db1df0 114 color=t
e1970ce4 115
e1970ce4
JH
116while test "$#" -ne 0
117do
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
886856ab
JH
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
5e2c08c6 123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 125 -h|--h|--he|--hel|--help)
570f3226 126 help=t; shift ;;
e1970ce4
JH
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
1ece1274 129 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
133 --with-dashes)
134 with_dashes=t; shift ;;
55db1df0 135 --no-color)
faa4bc35 136 color=; shift ;;
4e1be63c 137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 138 valgrind=t; verbose=t; shift ;;
44138559
JS
139 --tee)
140 shift ;; # was handled already
f423ef5f
JK
141 --root=*)
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143 shift ;;
e1970ce4 144 *)
1f729dca 145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
146 esac
147done
148
55db1df0
PH
149if test -n "$color"; then
150 say_color () {
c2116a17
JH
151 (
152 TERM=$ORIGINAL_TERM
153 export TERM
55db1df0
PH
154 case "$1" in
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
1ece1274 159 *) test -n "$quiet" && return;;
55db1df0
PH
160 esac
161 shift
5099b99d 162 printf "%s" "$*"
55db1df0 163 tput sgr0
b8eecafd 164 echo
c2116a17 165 )
55db1df0
PH
166 }
167else
168 say_color() {
1ece1274 169 test -z "$1" && test -n "$quiet" && return
55db1df0 170 shift
5099b99d 171 echo "$*"
55db1df0
PH
172 }
173fi
174
175error () {
176 say_color error "error: $*"
6e7b5aaf 177 GIT_EXIT_OK=t
55db1df0
PH
178 exit 1
179}
180
181say () {
182 say_color info "$*"
183}
184
570f3226
MB
185test "${test_description}" != "" ||
186error "Test script did not set test_description."
187
188if test "$help" = "t"
189then
190 echo "$test_description"
191 exit 0
192fi
193
4d9d62fa 194exec 5>&1
e1970ce4
JH
195if test "$verbose" = "t"
196then
197 exec 4>&2 3>&1
198else
199 exec 4>/dev/null 3>/dev/null
200fi
201
202test_failure=0
203test_count=0
41ac414e
JH
204test_fixed=0
205test_broken=0
2d84e9fb 206test_success=0
e1970ce4 207
d998bd4a
ÆAB
208test_external_has_tap=0
209
faa4bc35 210die () {
6e7b5aaf
CB
211 code=$?
212 if test -n "$GIT_EXIT_OK"
213 then
214 exit $code
215 else
216 echo >&5 "FATAL: Unexpected exit with code $code"
217 exit 1
218 fi
faa4bc35
CB
219}
220
6e7b5aaf 221GIT_EXIT_OK=
35641310 222trap 'die' EXIT
41184273 223
02b35660
BD
224# The semantics of the editor variables are that of invoking
225# sh -c "$EDITOR \"$@\"" files ...
226#
227# If our trash directory contains shell metacharacters, they will be
228# interpreted if we just set $EDITOR directly, so do a little dance with
229# environment variables to work around this.
230#
231# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 232# that we're using.
02b35660
BD
233test_set_editor () {
234 FAKE_EDITOR="$1"
235 export FAKE_EDITOR
d33738d7
JN
236 EDITOR='"$FAKE_EDITOR"'
237 export EDITOR
02b35660
BD
238}
239
68cfc6f5
MG
240test_decode_color () {
241 sed -e 's/.\[1m/<WHITE>/g' \
242 -e 's/.\[31m/<RED>/g' \
243 -e 's/.\[32m/<GREEN>/g' \
244 -e 's/.\[33m/<YELLOW>/g' \
245 -e 's/.\[34m/<BLUE>/g' \
246 -e 's/.\[35m/<MAGENTA>/g' \
247 -e 's/.\[36m/<CYAN>/g' \
248 -e 's/.\[m/<RESET>/g'
249}
250
c4f3f551
SB
251q_to_nul () {
252 perl -pe 'y/Q/\000/'
253}
254
255q_to_cr () {
256 tr Q '\015'
257}
258
800f1104
JN
259q_to_tab () {
260 tr Q '\011'
261}
262
c4f3f551
SB
263append_cr () {
264 sed -e 's/$/Q/' | tr Q '\015'
265}
266
267remove_cr () {
268 tr '\015' Q | sed -e 's/Q$//'
269}
270
04509738
JH
271test_tick () {
272 if test -z "${test_tick+set}"
273 then
21afc41c 274 test_tick=1112911993
04509738
JH
275 else
276 test_tick=$(($test_tick + 60))
277 fi
21afc41c
JH
278 GIT_COMMITTER_DATE="$test_tick -0700"
279 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
280 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
281}
e1970ce4 282
00884968
JS
283# Call test_commit with the arguments "<message> [<file> [<contents>]]"
284#
285# This will commit a file with the given contents and the given commit
286# message. It will also add a tag with <message> as name.
287#
288# Both <file> and <contents> default to <message>.
289
290test_commit () {
e656fc97 291 file=${2:-"$1.t"}
00884968
JS
292 echo "${3-$1}" > "$file" &&
293 git add "$file" &&
294 test_tick &&
295 git commit -m "$1" &&
296 git tag "$1"
297}
298
299# Call test_merge with the arguments "<message> <commit>", where <commit>
300# can be a tag pointing to the commit-to-merge.
301
302test_merge () {
303 test_tick &&
304 git merge -m "$1" "$2" &&
305 git tag "$1"
306}
307
1f553918
JS
308# This function helps systems where core.filemode=false is set.
309# Use it instead of plain 'chmod +x' to set or unset the executable bit
310# of a file in the working directory and add it to the index.
311
312test_chmod () {
313 chmod "$@" &&
314 git update-index --add "--chmod=$@"
315}
316
a7bb3940
JS
317# Use test_set_prereq to tell that a particular prerequisite is available.
318# The prerequisite can later be checked for in two ways:
319#
320# - Explicitly using test_have_prereq.
321#
322# - Implicitly by specifying the prerequisite tag in the calls to
323# test_expect_{success,failure,code}.
324#
325# The single parameter is the prerequisite tag (a simple word, in all
326# capital letters by convention).
327
328test_set_prereq () {
329 satisfied="$satisfied$1 "
330}
331satisfied=" "
332
333test_have_prereq () {
93a57246
ÆAB
334 # prerequisites can be concatenated with ','
335 save_IFS=$IFS
336 IFS=,
337 set -- $*
338 IFS=$save_IFS
ce60653e
ÆAB
339
340 total_prereq=0
341 ok_prereq=0
342 missing_prereq=
343
93a57246
ÆAB
344 for prerequisite
345 do
ce60653e 346 total_prereq=$(($total_prereq + 1))
93a57246
ÆAB
347 case $satisfied in
348 *" $prerequisite "*)
ce60653e
ÆAB
349 ok_prereq=$(($ok_prereq + 1))
350 ;;
93a57246 351 *)
ce60653e
ÆAB
352 # Keep a list of missing prerequisites
353 if test -z "$missing_prereq"
354 then
355 missing_prereq=$prerequisite
356 else
357 missing_prereq="$prerequisite,$missing_prereq"
358 fi
93a57246
ÆAB
359 esac
360 done
ce60653e
ÆAB
361
362 test $total_prereq = $ok_prereq
a7bb3940
JS
363}
364
886856ab
JH
365# You are not expected to call test_ok_ and test_failure_ directly, use
366# the text_expect_* functions instead.
367
368test_ok_ () {
d5d9de1b 369 test_success=$(($test_success + 1))
5099b99d 370 say_color "" "ok $test_count - $@"
e1970ce4
JH
371}
372
886856ab 373test_failure_ () {
d5d9de1b 374 test_failure=$(($test_failure + 1))
5099b99d 375 say_color error "not ok - $test_count $1"
bf0dd8a8 376 shift
5099b99d 377 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 378 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
379}
380
41ac414e 381test_known_broken_ok_ () {
41ac414e 382 test_fixed=$(($test_fixed+1))
5099b99d 383 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
384}
385
386test_known_broken_failure_ () {
41ac414e 387 test_broken=$(($test_broken+1))
5099b99d 388 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 389}
886856ab
JH
390
391test_debug () {
8e832ebc 392 test "$debug" = "" || eval "$1"
e1970ce4
JH
393}
394
4d9d62fa 395test_run_ () {
b6b0afdc 396 test_cleanup=:
4d9d62fa 397 eval >&3 2>&4 "$1"
b6b0afdc 398 eval_ret=$?
3bf78867 399 eval >&3 2>&4 "$test_cleanup"
57e1538a
ÆAB
400 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
401 echo ""
402 fi
4d9d62fa
PR
403 return 0
404}
405
04ece593 406test_skip () {
8586f98b 407 test_count=$(($test_count+1))
04ece593
JH
408 to_skip=
409 for skp in $GIT_SKIP_TESTS
410 do
8586f98b 411 case $this_test.$test_count in
04ece593
JH
412 $skp)
413 to_skip=t
47e67d47 414 break
04ece593
JH
415 esac
416 done
a7bb3940
JS
417 if test -z "$to_skip" && test -n "$prereq" &&
418 ! test_have_prereq "$prereq"
419 then
420 to_skip=t
421 fi
04ece593
JH
422 case "$to_skip" in
423 t)
07431fc8
JN
424 of_prereq=
425 if test "$missing_prereq" != "$prereq"
426 then
427 of_prereq=" of $prereq"
428 fi
429
55db1df0 430 say_color skip >&3 "skipping test: $@"
07431fc8 431 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
432 : true
433 ;;
434 *)
435 false
436 ;;
437 esac
438}
439
e1970ce4 440test_expect_failure () {
a7bb3940 441 test "$#" = 3 && { prereq=$1; shift; } || prereq=
8e832ebc 442 test "$#" = 2 ||
a7bb3940 443 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
04ece593 444 if ! test_skip "$@"
e1970ce4 445 then
41ac414e 446 say >&3 "checking known breakage: $2"
04ece593 447 test_run_ "$2"
41ac414e 448 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 449 then
41ac414e 450 test_known_broken_ok_ "$1"
04ece593 451 else
6e7b5aaf 452 test_known_broken_failure_ "$1"
04ece593 453 fi
e1970ce4 454 fi
7a0cf2d0 455 echo >&3 ""
e1970ce4
JH
456}
457
458test_expect_success () {
a7bb3940 459 test "$#" = 3 && { prereq=$1; shift; } || prereq=
8e832ebc 460 test "$#" = 2 ||
a7bb3940 461 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
04ece593 462 if ! test_skip "$@"
e1970ce4 463 then
04ece593
JH
464 say >&3 "expecting success: $2"
465 test_run_ "$2"
466 if [ "$?" = 0 -a "$eval_ret" = 0 ]
467 then
468 test_ok_ "$1"
469 else
470 test_failure_ "$@"
471 fi
e1970ce4 472 fi
7a0cf2d0 473 echo >&3 ""
e1970ce4
JH
474}
475
d3bfdb75 476test_expect_code () {
a7bb3940 477 test "$#" = 4 && { prereq=$1; shift; } || prereq=
d3bfdb75 478 test "$#" = 3 ||
a7bb3940 479 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
04ece593 480 if ! test_skip "$@"
d3bfdb75 481 then
04ece593
JH
482 say >&3 "expecting exit code $1: $3"
483 test_run_ "$3"
484 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
485 then
486 test_ok_ "$2"
487 else
488 test_failure_ "$@"
489 fi
d3bfdb75 490 fi
7a0cf2d0 491 echo >&3 ""
d3bfdb75
FK
492}
493
fb32c410
LW
494# test_external runs external test scripts that provide continuous
495# test output about their progress, and succeeds/fails on
496# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 497# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
498# <n>: ..." before running it. When providing relative paths, keep in
499# mind that all scripts run in "trash directory".
500# Usage: test_external description command arguments...
501# Example: test_external 'Perl API' perl ../path/to/test.pl
502test_external () {
a7bb3940
JS
503 test "$#" = 4 && { prereq=$1; shift; } || prereq=
504 test "$#" = 3 ||
505 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
506 descr="$1"
507 shift
508 if ! test_skip "$descr" "$@"
509 then
510 # Announce the script to reduce confusion about the
511 # test output that follows.
d998bd4a 512 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
513 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
514 # to be able to use them in script
515 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
516 # Run command; redirect its stderr to &4 as in
517 # test_run_, but keep its stdout on our stdout even in
518 # non-verbose mode.
519 "$@" 2>&4
520 if [ "$?" = 0 ]
521 then
d998bd4a
ÆAB
522 if test $test_external_has_tap -eq 0; then
523 test_ok_ "$descr"
524 else
525 say_color "" "# test_external test $descr was ok"
526 test_success=$(($test_success + 1))
527 fi
fb32c410 528 else
d998bd4a
ÆAB
529 if test $test_external_has_tap -eq 0; then
530 test_failure_ "$descr" "$@"
531 else
532 say_color error "# test_external test $descr failed: $@"
533 test_failure=$(($test_failure + 1))
534 fi
fb32c410
LW
535 fi
536 fi
537}
538
539# Like test_external, but in addition tests that the command generated
540# no output on stderr.
541test_external_without_stderr () {
542 # The temporary file has no (and must have no) security
543 # implications.
544 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
545 stderr="$tmp/git-external-stderr.$$.tmp"
546 test_external "$@" 4> "$stderr"
547 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
548 descr="no stderr: $1"
549 shift
d998bd4a 550 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
551 if [ ! -s "$stderr" ]; then
552 rm "$stderr"
d998bd4a
ÆAB
553
554 if test $test_external_has_tap -eq 0; then
555 test_ok_ "$descr"
556 else
557 say_color "" "# test_external_without_stderr test $descr was ok"
558 test_success=$(($test_success + 1))
559 fi
fb32c410
LW
560 else
561 if [ "$verbose" = t ]; then
d998bd4a 562 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
563 else
564 output=
565 fi
566 # rm first in case test_failure exits.
567 rm "$stderr"
d998bd4a
ÆAB
568 if test $test_external_has_tap -eq 0; then
569 test_failure_ "$descr" "$@" "$output"
570 else
571 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
572 test_failure=$(($test_failure + 1))
573 fi
fb32c410
LW
574 fi
575}
576
2caf20c5
MM
577# debugging-friendly alternatives to "test [-f|-d|-e]"
578# The commands test the existence or non-existence of $1. $2 can be
579# given to provide a more precise diagnosis.
580test_path_is_file () {
581 if ! [ -f "$1" ]
582 then
583 echo "File $1 doesn't exist. $*"
584 false
585 fi
586}
587
588test_path_is_dir () {
589 if ! [ -d "$1" ]
590 then
591 echo "Directory $1 doesn't exist. $*"
592 false
593 fi
594}
595
596test_path_is_missing () {
597 if [ -e "$1" ]
598 then
599 echo "Path exists:"
600 ls -ld "$1"
601 if [ $# -ge 1 ]; then
602 echo "$*"
603 fi
604 false
605 fi
606}
607
608
74359821
JH
609# This is not among top-level (test_expect_success | test_expect_failure)
610# but is a prefix that can be used in the test script, like:
611#
612# test_expect_success 'complain and die' '
613# do something &&
614# do something else &&
615# test_must_fail git checkout ../outerspace
616# '
617#
618# Writing this as "! git checkout ../outerspace" is wrong, because
619# the failure could be due to a segv. We want a controlled failure.
620
621test_must_fail () {
622 "$@"
16034fbe
JK
623 exit_code=$?
624 if test $exit_code = 0; then
625 echo >&2 "test_must_fail: command succeeded: $*"
626 return 1
627 elif test $exit_code -gt 129 -a $exit_code -le 192; then
628 echo >&2 "test_must_fail: died by signal: $*"
629 return 1
a54ce3ca
JK
630 elif test $exit_code = 127; then
631 echo >&2 "test_must_fail: command not found: $*"
632 return 1
16034fbe
JK
633 fi
634 return 0
74359821
JH
635}
636
fdf1bc48
JN
637# Similar to test_must_fail, but tolerates success, too. This is
638# meant to be used in contexts like:
639#
640# test_expect_success 'some command works without configuration' '
641# test_might_fail git config --unset all.configuration &&
642# do something
643# '
644#
645# Writing "git config --unset all.configuration || :" would be wrong,
646# because we want to notice if it fails due to segv.
647
648test_might_fail () {
649 "$@"
5c8e1414
JN
650 exit_code=$?
651 if test $exit_code -gt 129 -a $exit_code -le 192; then
652 echo >&2 "test_might_fail: died by signal: $*"
653 return 1
d0b8a617
JN
654 elif test $exit_code = 127; then
655 echo >&2 "test_might_fail: command not found: $*"
656 return 1
5c8e1414
JN
657 fi
658 return 0
fdf1bc48
JN
659}
660
82ebb0b6
JK
661# test_cmp is a helper function to compare actual and expected output.
662# You can use it like:
663#
664# test_expect_success 'foo works' '
665# echo expected >expected &&
666# foo >actual &&
667# test_cmp expected actual
668# '
669#
670# This could be written as either "cmp" or "diff -u", but:
671# - cmp's output is not nearly as easy to read as diff -u
672# - not all diff versions understand "-u"
673
674test_cmp() {
675 $GIT_TEST_CMP "$@"
676}
677
3bf78867
JN
678# This function can be used to schedule some commands to be run
679# unconditionally at the end of the test to restore sanity:
680#
681# test_expect_success 'test core.capslock' '
682# git config core.capslock true &&
683# test_when_finished "git config --unset core.capslock" &&
684# hello world
685# '
686#
687# That would be roughly equivalent to
688#
689# test_expect_success 'test core.capslock' '
690# git config core.capslock true &&
691# hello world
692# git config --unset core.capslock
693# '
694#
695# except that the greeting and config --unset must both succeed for
696# the test to pass.
697
698test_when_finished () {
b6b0afdc
JN
699 test_cleanup="{ $*
700 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
701}
702
0509eb21 703# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
704# Usage: test_create_repo <directory>
705test_create_repo () {
706 test "$#" = 1 ||
707 error "bug in the test script: not 1 parameter to test-create-repo"
eedf8f97 708 repo="$1"
bfdbee98 709 mkdir -p "$repo"
0d314ce8
ÆAB
710 (
711 cd "$repo" || error "Cannot setup test environment"
712 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
713 error "cannot run git init -- have you built things yet?"
714 mv .git/hooks .git/hooks-disabled
715 ) || exit
eedf8f97 716}
a6080a0a 717
e1970ce4 718test_done () {
6e7b5aaf 719 GIT_EXIT_OK=t
2d84e9fb 720
8ef1abe5
ÆAB
721 if test -z "$HARNESS_ACTIVE"; then
722 test_results_dir="$TEST_DIRECTORY/test-results"
723 mkdir -p "$test_results_dir"
724 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
725
726 echo "total $test_count" >> $test_results_path
727 echo "success $test_success" >> $test_results_path
728 echo "fixed $test_fixed" >> $test_results_path
729 echo "broken $test_broken" >> $test_results_path
730 echo "failed $test_failure" >> $test_results_path
731 echo "" >> $test_results_path
732 fi
41ac414e
JH
733
734 if test "$test_fixed" != 0
735 then
5099b99d 736 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
737 fi
738 if test "$test_broken" != 0
739 then
5099b99d 740 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
741 msg="remaining $(($test_count-$test_broken)) test(s)"
742 else
743 msg="$test_count test(s)"
41ac414e 744 fi
e1970ce4 745 case "$test_failure" in
10b94e28 746 0)
5099b99d
ÆAB
747 # Maybe print SKIP message
748 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
749
d998bd4a
ÆAB
750 if test $test_external_has_tap -eq 0; then
751 say_color pass "# passed all $msg"
752 say "1..$test_count$skip_all"
753 fi
abc5d372
JS
754
755 test -d "$remove_trash" &&
756 cd "$(dirname "$remove_trash")" &&
757 rm -rf "$(basename "$remove_trash")"
758
e1970ce4
JH
759 exit 0 ;;
760
761 *)
d998bd4a
ÆAB
762 if test $test_external_has_tap -eq 0; then
763 say_color error "# failed $test_failure among $msg"
764 say "1..$test_count"
765 fi
5099b99d 766
e1970ce4
JH
767 exit 1 ;;
768
769 esac
770}
771
772# Test the binaries we have just built. The tests are kept in
9adefee5 773# t/ subdirectory and are run in 'trash directory' subdirectory.
62f53904
ÆAB
774if test -z "$TEST_DIRECTORY"
775then
776 # We allow tests to override this, in case they want to run tests
777 # outside of t/, e.g. for running tests on the test library
778 # itself.
779 TEST_DIRECTORY=$(pwd)
780fi
6cec5c68
ÆAB
781GIT_BUILD_DIR="$TEST_DIRECTORY"/..
782
e4597aae 783if test -n "$valgrind"
4e1be63c 784then
4e1be63c
JS
785 make_symlink () {
786 test -h "$2" &&
787 test "$1" = "$(readlink "$2")" || {
788 # be super paranoid
789 if mkdir "$2".lock
790 then
791 rm -f "$2" &&
792 ln -s "$1" "$2" &&
793 rm -r "$2".lock
794 else
795 while test -d "$2".lock
796 do
797 say "Waiting for lock on $2."
798 sleep 1
799 done
800 fi
801 }
802 }
803
804 make_valgrind_symlink () {
805 # handle only executables
806 test -x "$1" || return
807
808 base=$(basename "$1")
6cec5c68 809 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
810 # do not override scripts
811 if test -x "$symlink_target" &&
812 test ! -d "$symlink_target" &&
813 test "#!" != "$(head -c 2 < "$symlink_target")"
814 then
815 symlink_target=../valgrind.sh
816 fi
efd92ffd
JS
817 case "$base" in
818 *.sh|*.perl)
819 symlink_target=../unprocessed-script
820 esac
4e1be63c
JS
821 # create the link, or replace it if it is out of date
822 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
823 }
824
825 # override all git executables in TEST_DIRECTORY/..
826 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
827 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 828 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
829 do
830 make_valgrind_symlink $file
831 done
efd92ffd
JS
832 OLDIFS=$IFS
833 IFS=:
834 for path in $PATH
835 do
836 ls "$path"/git-* 2> /dev/null |
837 while read file
838 do
839 make_valgrind_symlink "$file"
840 done
841 done
842 IFS=$OLDIFS
4e1be63c
JS
843 PATH=$GIT_VALGRIND/bin:$PATH
844 GIT_EXEC_PATH=$GIT_VALGRIND/bin
845 export GIT_VALGRIND
e4597aae
MO
846elif test -n "$GIT_TEST_INSTALLED" ; then
847 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
848 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 849 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
850 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
851else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 852 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
e4597aae
MO
853 if ! test -x "$git_bin_dir/git" ; then
854 if test -z "$with_dashes" ; then
855 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
856 fi
857 with_dashes=t
858 fi
859 PATH="$git_bin_dir:$PATH"
6cec5c68 860 GIT_EXEC_PATH=$GIT_BUILD_DIR
e4597aae 861 if test -n "$with_dashes" ; then
6cec5c68 862 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 863 fi
4e1be63c 864fi
6cec5c68 865GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 866unset GIT_CONFIG
8bfa6bd6
JK
867GIT_CONFIG_NOSYSTEM=1
868GIT_CONFIG_NOGLOBAL=1
869export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
49ccb087 870
aed604c7 871. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
ac10a857 872
5e87eae9
JH
873if test -z "$GIT_TEST_CMP"
874then
875 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
876 then
877 GIT_TEST_CMP="$DIFF -c"
878 else
879 GIT_TEST_CMP="$DIFF -u"
880 fi
881fi
882
6cec5c68 883GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 884export GITPERLLIB
6cec5c68 885test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
886 error "You haven't built things yet, have you?"
887}
e1970ce4 888
ac10a857 889if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 890then
6cec5c68 891 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 892 export GITPYTHONLIB
6cec5c68 893 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
894 error "You haven't built git_remote_helpers yet, have you?"
895 }
896fi
897
6cec5c68 898if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
56cf9806
EW
899 echo >&2 'You need to build test-chmtime:'
900 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
901 exit 1
902fi
903
e1970ce4 904# Test repository
abc5d372 905test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
906test -n "$root" && test="$root/$test"
907case "$test" in
908/*) TRASH_DIRECTORY="$test" ;;
909 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
910esac
91c8b825 911test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 912rm -fr "$test" || {
6e7b5aaf 913 GIT_EXIT_OK=t
8d14ac94
JH
914 echo >&5 "FATAL: Cannot prepare test area"
915 exit 1
916}
917
4a7aaccd 918test_create_repo "$test"
1bd9c648
LW
919# Use -P to resolve symlinks in our working directory so that the cwd
920# in subprocesses like git equals our $PWD (for pathname comparisons).
921cd -P "$test" || exit 1
04ece593 922
e4c62e64
MM
923HOME=$(pwd)
924export HOME
925
d5d9de1b
JS
926this_test=${0##*/}
927this_test=${this_test%%-*}
04ece593
JH
928for skp in $GIT_SKIP_TESTS
929do
47e67d47
MG
930 case "$this_test" in
931 $skp)
55db1df0 932 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 933 skip_all="skip all tests in $this_test"
04ece593
JH
934 test_done
935 esac
936done
f17e9fbb 937
8648732e
BC
938# Provide an implementation of the 'yes' utility
939yes () {
940 if test $# = 0
941 then
942 y=y
943 else
944 y="$*"
945 fi
946
947 while echo "$y"
948 do
949 :
950 done
951}
952
f17e9fbb
JS
953# Fix some commands on Windows
954case $(uname -s) in
955*MINGW*)
956 # Windows has its own (incompatible) sort and find
957 sort () {
958 /usr/bin/sort "$@"
959 }
960 find () {
961 /usr/bin/find "$@"
962 }
5397ea31
JS
963 sum () {
964 md5sum "$@"
965 }
4114156a
JS
966 # git sees Windows-style pwd
967 pwd () {
968 builtin pwd -W
969 }
ee9fb68c 970 # no POSIX permissions
6fd1106a 971 # backslashes in pathspec are converted to '/'
fb9a2bea 972 # exec does not inherit the PID
a94114ad 973 test_set_prereq MINGW
ee9fb68c
JS
974 ;;
975*)
976 test_set_prereq POSIXPERM
6fd1106a 977 test_set_prereq BSLASHPSPEC
fb9a2bea 978 test_set_prereq EXECKEEPSPID
3ba9ba8f 979 test_set_prereq NOT_MINGW
f17e9fbb
JS
980 ;;
981esac
704a3143 982
1b19ccd2 983test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 984test -z "$NO_PYTHON" && test_set_prereq PYTHON
1b19ccd2 985
704a3143
JS
986# test whether the filesystem supports symbolic links
987ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
988rm -f y
c91cfd19
ÆAB
989
990# When the tests are run as root, permission tests will report that
991# things are writable when they shouldn't be.
992test -w / || test_set_prereq SANITY